/*
 * Go2ProfilePositionZ.c
 * 
 * Gocator system communication library
 * Copyright (C) 2013 by LMI Technologies Inc.
 * 
 * Licensed under The MIT License.
 * Redistributions of files must retain the above copyright notice.
 */

#include <z/Go2Measurements/zGo2ProfilePositionZ.h>
#include <z/zGo2ProfileTypes.h>
#include <z/zGo2System.h>
#include <string.h>

/*
 * Go2ProfilePositionZ Class 
 */

GO2_EXPORT(Go2Status) Go2ProfilePositionZ_Construct(Go2ProfilePositionZ* measurement, Go2UInt32 id, Go2Object system)
{
    Go2ProfilePositionZ output = zNIL; 
    Go2Status status = GO2_OK; 

    zCHECK(zCalloc(&output, 1, sizeof(Go2ProfilePositionZClass))); 

    if (!zSUCCESS(status = Go2ProfilePositionZ_Init(output, id, system)))
    {
        zCHECK(Go2Object_Destroy(output)); 
        return status; 
    }
    
    *measurement = output; 

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfilePositionZ_Init(Go2ProfilePositionZ measurement, Go2UInt32 id, Go2Object system)
{
    Go2ProfilePositionZClass* obj = zHANDLE_POINTER(measurement);

    zCHECK(Go2Measurement_Init(measurement, GO2_TYPE_PROFILE_POSITION_Z, id, system)); 

    obj->Release = Go2ProfilePositionZ_VRelease; 
    obj->Read = Go2ProfilePositionZ_VRead; 
    obj->Write = Go2ProfilePositionZ_VWrite; 

    zCHECK(Go2ProfileFeature_Construct(&obj->feature, system));       

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfilePositionZ_VRelease(Go2ProfilePositionZ measurement)
{
    Go2ProfilePositionZClass* obj = zHANDLE_POINTER(measurement);

    zCHECK(Go2Object_Destroy(obj->feature)); 

    zCHECK(Go2Measurement_VRelease(measurement));  
        
    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfilePositionZ_VRead(Go2ProfilePositionZ measurement, zXml xml, zXmlItem item)
{
    Go2ProfilePositionZClass* obj = zHANDLE_POINTER(measurement); 
    zChar* text = zNULL;
    z32u textCapacity = GO2_MEASUREMENT_SOURCE_TEXT_CAPACITY; 
 
    zXmlItem featureItem = zNIL; 

    zCHECK(Go2Measurement_VRead(measurement, xml, item)); 

    zCHECK(zCalloc(&text, textCapacity, sizeof(zChar)));
    zCHECK(zXml_ChildText(xml, item, "SourceOptions", text, textCapacity)); 
    zCHECK(Go2OptionList_ParseList(text, obj->sourceOptions));  

    zCHECK(zXml_Child32u(xml, item, "Source", &obj->source)); 
    

    zCHECK(!zIS_NIL(featureItem = zXml_Child(xml, item, "Feature"))); 
    zCHECK(Go2ProfileFeature_Read(obj->feature, xml, featureItem)); 

    zCHECK(zFree(text));

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfilePositionZ_VWrite(Go2ProfilePositionZ measurement, zXml xml, zXmlItem item)
{
    Go2ProfilePositionZClass* obj = zHANDLE_POINTER(measurement); 
    zXmlItem featureItem = zNIL; 

    zCHECK(Go2Measurement_VWrite(measurement, xml, item)); 

    zCHECK(zXml_SetChild32u(xml, item, "Source", obj->source)); 

    zCHECK(zXml_AddItem(xml, item, "Feature", &featureItem)); 
    zCHECK(Go2ProfileFeature_Write(obj->feature, xml, featureItem)); 

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfilePositionZ_SetId(Go2ProfilePositionZ measurement, Go2UInt32 id)
{
    return Go2Measurement_SetId(measurement, id);     
}

GO2_EXPORT(Go2UInt32) Go2ProfilePositionZ_Id(Go2ProfilePositionZ measurement)
{
    return Go2Measurement_Id(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfilePositionZ_SetName(Go2ProfilePositionZ measurement, const Go2Char* name)
{
    return Go2Measurement_SetName(measurement, name);     
}

GO2_EXPORT(Go2Status) Go2ProfilePositionZ_Name(Go2ProfilePositionZ measurement, Go2Char* name, Go2UInt32 capacity)
{
    return Go2Measurement_Name(measurement, name, capacity);     
}

GO2_EXPORT(Go2UInt32) Go2ProfilePositionZ_SourceOptionCount(Go2ProfilePositionZ measurement)
{
    return Go2Measurement_SourceOptionCount(measurement);     
}

GO2_EXPORT(Go2ProfileSource) Go2ProfilePositionZ_SourceOptionAt(Go2ProfilePositionZ measurement, Go2UInt32 index)
{
    return Go2Measurement_SourceOptionAt(measurement, index);     
}

GO2_EXPORT(Go2Status) Go2ProfilePositionZ_SetSource(Go2ProfilePositionZ measurement, Go2ProfileSource source)
{
    return Go2Measurement_SetSource(measurement, source);     
}

GO2_EXPORT(Go2ProfileSource) Go2ProfilePositionZ_Source(Go2ProfilePositionZ measurement)
{
    return Go2Measurement_Source(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfilePositionZ_SetDecisionMin(Go2ProfilePositionZ measurement, Go2Double min)
{
    return Go2Measurement_SetDecisionMin(measurement, min);     
}

GO2_EXPORT(Go2Double) Go2ProfilePositionZ_DecisionMin(Go2ProfilePositionZ measurement)
{
    return Go2Measurement_DecisionMin(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfilePositionZ_SetDecisionMax(Go2ProfilePositionZ measurement, Go2Double max)
{
    return Go2Measurement_SetDecisionMax(measurement, max);     
}

GO2_EXPORT(Go2Double) Go2ProfilePositionZ_DecisionMax(Go2ProfilePositionZ measurement)
{
    return Go2Measurement_DecisionMax(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfilePositionZ_EnableHold(Go2ProfilePositionZ measurement, Go2Bool enable)
{
    return Go2Measurement_EnableHold(measurement, enable);  
} 

GO2_EXPORT(Go2Bool) Go2ProfilePositionZ_HoldEnabled(Go2ProfilePositionZ measurement)
{
    return Go2Measurement_HoldEnabled(measurement);  
}

GO2_EXPORT(Go2Status) Go2ProfilePositionZ_EnableSmoothing(Go2ProfilePositionZ measurement, Go2Bool enable)
{
    return Go2Measurement_EnableSmoothing(measurement, enable);  
} 

GO2_EXPORT(Go2Bool) Go2ProfilePositionZ_SmoothingEnabled(Go2ProfilePositionZ measurement)
{
    return Go2Measurement_SmoothingEnabled(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfilePositionZ_SmoothingWindowMin(Go2ProfilePositionZ measurement)
{
    return Go2Measurement_SmoothingWindowMin(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfilePositionZ_SmoothingWindowMax(Go2ProfilePositionZ measurement)
{
    return Go2Measurement_SmoothingWindowMax(measurement);  
} 

GO2_EXPORT(Go2Status) Go2ProfilePositionZ_SetSmoothingWindow(Go2ProfilePositionZ measurement, Go2UInt32 window)
{
    return Go2Measurement_SetSmoothingWindow(measurement, window);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfilePositionZ_SmoothingWindow(Go2ProfilePositionZ measurement)
{
    return Go2Measurement_SmoothingWindow(measurement);  
} 

GO2_EXPORT(Go2ProfileFeature) Go2ProfilePositionZ_Feature(Go2ProfilePositionZ measurement)
{
    Go2ProfilePositionZClass* obj = zHANDLE_POINTER(measurement); 
    return obj->feature;  
}



GO2_EXPORT(Go2Status) Go2ProfilePositionZ_SetScale(Go2ProfilePositionZ measurement, Go2Double scale){
    return Go2Measurement_SetScale(measurement, scale);
}

GO2_EXPORT(Go2Double) Go2ProfilePositionZ_Scale(Go2ProfilePositionZ measurement){
    return Go2Measurement_Scale(measurement);
}

GO2_EXPORT(Go2Status) Go2ProfilePositionZ_SetOffset(Go2ProfilePositionZ measurement, Go2Double offset){
    return Go2Measurement_SetOffset(measurement, offset);
}

GO2_EXPORT(Go2Double) Go2ProfilePositionZ_Offset(Go2ProfilePositionZ measurement){
    return Go2Measurement_Offset(measurement);
}

GO2_EXPORT(Go2UInt32) Go2ProfilePositionZ_LinkOptionCount(Go2ProfilePositionZ measurement)
{
    return Go2Measurement_LinkOptionCount(measurement);
}

GO2_EXPORT(Go2UInt32) Go2ProfilePositionZ_LinkOptionAt(Go2ProfilePositionZ measurement, Go2UInt32 index)
{
    return Go2Measurement_LinkOptionAt(measurement, index);
}

GO2_EXPORT(Go2Status) Go2ProfilePositionZ_EnableLink(Go2ProfilePositionZ measurement, Go2Bool enable)  
{
    return Go2Measurement_EnableLink(measurement, enable);  
}

GO2_EXPORT(Go2Bool) Go2ProfilePositionZ_LinkEnabled(Go2ProfilePositionZ measurement)  
{
    return Go2Measurement_LinkEnabled(measurement);  
}

GO2_EXPORT(Go2Status) Go2ProfilePositionZ_SetLink(Go2ProfilePositionZ measurement, Go2UInt32 link) 
{
    return Go2Measurement_SetLink(measurement, link); 
}

GO2_EXPORT(Go2UInt32) Go2ProfilePositionZ_Link(Go2ProfilePositionZ measurement) 
{
    return Go2Measurement_Link(measurement); 
}
